/* "VBC" ::CopyLeft, GNU and Gary Kline and many others, 2011, 2012 */

/*
 ** Start of program code
 **/


#include <gtk/gtk.h>
#include <stdio.h>
#include <string.h>
#include "vbc.h"

/* from here make this into:: Options callback */
#include <stdlib.h>   // for exit()

/*
 * directory created, configurated, and ready...?
 *
 * critical variable.
 *
 */

/* globals */
int valueGender = MALE;  // default 
double valueDelay;
gint valueVolume;
gint valueSpeed;
gint valuePitch;

const char *homedir;
gboolean looping_flag;

static int counter = 1;
GtkWidget *label;		// *Dec_button;
static const char suffix[] = ".txt";
static char *prefix;
gchar *vhome;

/*  next and last globals */
int next_invalid;

/* end globals */

void show_file_in_new_window (void);

/* 
 * Function to open a dialog box displaying the message provided. 
 */
void
quick_message (const gchar * message, GtkWidget * parent)
{

   GtkWidget *dialog;

   /*
      Create the widgets 
    */
   dialog = gtk_message_dialog_new (GTK_WINDOW (parent),
				GTK_DIALOG_DESTROY_WITH_PARENT, GTK_MESSAGE_OTHER,
				GTK_BUTTONS_OK, message);

   /*
      Ensure that the dialog box is destroyed when the user responds. 
    */
   g_signal_connect_swapped (dialog, "response",
			     G_CALLBACK (gtk_widget_destroy), dialog);

   /*
      show everything we've added to the dialog. 
    */
   gtk_widget_show_all (dialog);
}

/* Obligatory basic callback  MENU */
static void
print_hello (void)
{
   g_message ("Hello, World!\n");
}

void
enter_callback (GtkWidget * widget, gpointer user_data)
{
   const gchar *entry_text = gtk_entry_get_text (GTK_ENTRY (widget));
   printf ("Entry contents: %s\n", entry_text);
}


/*
 * this is Only for non-gvim calls: 08jan, 2012
 */
void
play_voice_button_cb (void)
{
   if (counter >= 1)
     {
        gchar *ifbuf, *accessbuf, *voice;

        ifbuf = g_strdup_printf ("%s%c%d%s", prefix, DOT, counter, suffix);
        accessbuf = g_build_filename (homedir, VBCPATH, ifbuf, NULL);
	voice = g_strdup_printf ("%s -a %i -p %i -s %i %s -f %s %s | %s",ESPEAK,
	 valueVolume, valuePitch, valueSpeed, LANG, accessbuf, OUT, APLAY);
	printf ("BEBUG: play_voice_button_CB: voice = [%s]\n", voice);
        g_free (voice);
        g_free (accessbuf);
        g_free (ifbuf);
     }
}


void
check_last_textfile_cb (GtkButton *button, GtkWidget *showindow)
{
   gchar *ifbuf, *accessbuf;

   printf ("\nEntering check_last_textfile_cb(): counter = (%d)", counter);

   counter--;
   if (counter < 1)
      //if (counter <= 1) // 28dec2012 :: likely.... []
     {
	counter = 1;
	next_invalid = TRUE;
	printf ("\nLAST_DEBUG: After --: counter = (%d)", counter);
	if (next_invalid == TRUE)
	  {
	     quick_message
		("Last no more files to speak; click the OK button",
		 showindow);
	  }
	puts ("RETURN");
	return;

     }
   //puts("\nLdebug: === access() check");
   ifbuf = g_strdup_printf ("%s%c%d%s", prefix, DOT, counter, suffix);
   accessbuf = g_build_filename (homedir, VBCPATH, ifbuf, NULL);

   if (access (accessbuf, F_OK| R_OK) == 0)	// file exists and readable
     {
        next_invalid = FALSE;
       show_file_in_new_window ();
     }
   else
     {

	printf ("check_last: counter = (%d)\n", counter);
		/***
		next_invalid = TRUE;
	   if (next_invalid == TRUE )
	   {
	       quick_message("Last no more files to speak; click the OK button",
	showindow);
	   
	   }
	   ***/

     }
   //g_free (ifbuf);
   //g_free (accessbuf);

   return;
}



void
check_next_textfile_cb (GtkButton *button, GtkWidget *showindow)
{
   gchar *ifbuf, *accessbuf;

   printf ("\nEntering check_next() with counter = (%d)", counter);
   counter++;
   printf ("\nNEXT_DEBUG: after ++ check_next_textfile_cb(): counter = (%d)",
	   counter);
   //puts("\nZdebug: === access() check");
   ifbuf = g_strdup_printf ("%s%c%d%s", prefix, DOT, counter, suffix);
   accessbuf = g_build_filename (homedir, VBCPATH, ifbuf, NULL);

   if (access (accessbuf, F_OK | R_OK) == 0)	// file exists and readable
     {
         next_invalid = FALSE;
         show_file_in_new_window ();
     }
   else
     {
	next_invalid = TRUE;
	if (next_invalid == TRUE)
	  {
	     quick_message
		("Next no more files to speak; click the OK button",
		 showindow);
	  }

     }

   ////g_free (accessbuf);
   //g_free (ifbuf);
}



// line 415 [[ 27dec12 ]]
void
show_file_in_new_window (void)
{
   GtkWidget *showindow;
   GtkWidget *view, *vbox, *separator;
   GtkWidget *prevbtn, *nextbtn, *closebtn;
   GtkWidget *frame, *play;
   GtkTextBuffer *buffer;
   GtkTextIter iter;
   FILE *infile;
   gchar file_buff[MAXCHAT];
   gint nchars;
   gchar *filename;
   gchar *ifbuf, *accessbuf;

   visitX =1;  //  it's sokmething like this.

   if (counter < 1) return;

   ifbuf = g_strdup_printf ("%s%c%d%s", prefix, DOT, counter, suffix);
   accessbuf = g_build_filename (homedir, VBCPATH, ifbuf, NULL);

   //printf("DEBUG: show_file: accessbuf = [%s], ifbuf = [%s]\n", accessbuf, ifbuf);
   showindow = gtk_window_new (GTK_WINDOW_TOPLEVEL);
   gtk_window_set_default_size (GTK_WINDOW (showindow), 500, 500);

   gtk_window_set_title (GTK_WINDOW (showindow), ifbuf);

   gtk_widget_set_size_request (showindow, 200, 200);
   gtk_container_set_border_width (GTK_CONTAINER (showindow), 8);

/* i add a frame around the vbox to make things look better */
   frame = gtk_frame_new ("Speak text");
   gtk_container_add (GTK_CONTAINER (showindow), frame);

   vbox = gtk_vbox_new (FALSE, 5);
   gtk_container_add (GTK_CONTAINER (frame), vbox);
/* now we added a vbox container, to our frame*/

   view = gtk_text_view_new ();
   gtk_container_set_border_width (GTK_CONTAINER (view), 6);
   gtk_container_add (GTK_CONTAINER (vbox), view);
/* added the text view to the vbox */

   separator = gtk_hseparator_new ();
   gtk_box_pack_start (GTK_BOX (vbox), separator, FALSE, TRUE, 0);

/* using box packing allows automatic sizing, good idea for
* a seperator (let gtk figure it out)
* so now we packed a seperator below our text view */
   GtkWidget *hbox = gtk_hbutton_box_new ();
   gtk_button_box_set_layout (GTK_BUTTON_BOX (hbox), GTK_BUTTONBOX_END);
   gtk_container_set_border_width (GTK_CONTAINER (hbox), 2);
   gtk_box_pack_start (GTK_BOX (vbox), hbox, FALSE, TRUE, 0);

   play = gtk_button_new_from_stock (GTK_STOCK_MEDIA_PLAY);
   g_signal_connect (play, "clicked", G_CALLBACK (play_voice_button_cb),
		     NULL);

   /*
      Last button and its callback 
    */
   prevbtn = gtk_button_new_with_label ("Last");
   g_signal_connect (prevbtn, "clicked", G_CALLBACK (check_last_textfile_cb),
		     showindow);

   /*
      next button and its callback 
    */
   nextbtn = gtk_button_new_with_label ("Next");

   g_signal_connect (nextbtn, "clicked", G_CALLBACK (check_next_textfile_cb),
		     showindow);

   /*
      close showindow button 
    */
   closebtn = gtk_button_new_from_stock (GTK_STOCK_CLOSE);

   gtk_box_pack_start (GTK_BOX (hbox), play, TRUE, TRUE, FALSE);
   gtk_box_pack_start (GTK_BOX (hbox), prevbtn, TRUE, TRUE, FALSE);
   gtk_box_pack_start (GTK_BOX (hbox), nextbtn, TRUE, TRUE, FALSE);
   gtk_box_pack_end (GTK_BOX (hbox), closebtn, TRUE, TRUE, FALSE);

/* again using packing for auto sizing, we add the buttons
* to the hbox, which will get placed below the separator
* packing start = from left to right.
*/

/* fetch the buffer from the text view and get offset 0 */
   buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (view));
   gtk_text_buffer_get_iter_at_offset (buffer, &iter, 0);

/* pull in data from file and insert starting at iter */

   filename = g_build_filename (vhome, ifbuf, NULL);
   infile = fopen (filename, "r");
   if (infile)
     {
	while (1)
	  {
	     nchars = fread (file_buff, 1, MAXCHAT, infile);
	     gtk_text_buffer_insert (buffer, &iter, file_buff, nchars);
	     if (nchars < MAXCHAT)
		break;
	  }
	fclose (infile);
     }
   else
      g_print ("\nERROR! could not open %s\n", filename);
   //g_free (filename);
   //g_free (accessbuf);
   //g_free (ifbuf);

/* since this button is to remove the window, i pass
* the window as the data and then pass the window
* to gtk_widget_destroy() inside the cb 
*/

   g_signal_connect_swapped (closebtn, "clicked", G_CALLBACK (gtk_widget_destroy),
		     showindow);

   gtk_widget_show_all (showindow);
}

// line 534  [27dec12]  {end of "show_file"}  // SHOW



// START 454
static void
update_label (void)
{
   gchar *buf;

/*
If counter is < 1, use markup to highlight text
*/
   if (counter <= 0)
     {
	g_print ("Please increase file number to at least \"1\"\n");
     }
   if (counter >= 1)
     {
	if (prefix)
	  {
	     buf = g_strdup_printf (
			 "<span foreground=\"red\" background=\"yellow\"size=\"x-large\">%s%c%d%s</span>",
			 prefix, DOT, counter, suffix);
	  }
	else
	  {
	     buf = g_strdup_printf (
			 "<span foreground=\"red\" background=\"yellow\" size=\"x-large\">%d%s</span>",
			 counter, suffix);
	  }
	gtk_label_set_markup (GTK_LABEL (label), buf);
        //g_free (buf);
     }
   else
     {
	if (prefix)
	  {
	     buf = g_strdup_printf ("%s%c%d%s", prefix, DOT, counter,
			 suffix);
	  }
	else
	  {
	     buf = g_strdup_printf ("%d%s", counter, suffix);
	  }
	gtk_label_set_label (GTK_LABEL (label), buf);
        //g_free (buf);
     }
}

// END 239
#ifdef XXX
static void
inc_button_click_cb (GtkButton * button, gpointer data)
{
   GtkWidget *dec_button = data;
   counter++;
/*
Change senstivity of the decrement button based on counter
*/
   if (counter > 0 && !gtk_widget_is_sensitive (dec_button))
      gtk_widget_set_sensitive (dec_button, TRUE);
   /*
      Update label to show updated counter
    */

   update_label ();
}

static void
dec_button_click_cb (GtkButton * button, gpointer data)
{
   counter--;
   if (counter <= 0)
     {
	counter = 1;
     }

/*
Change senstivity of the decrement button based on counter
*/
   if (counter < 1 && gtk_widget_is_sensitive (GTK_WIDGET (button)))
      gtk_widget_set_sensitive (GTK_WIDGET (button), FALSE);
   /*
    * Update label to show updated counter
    */

   update_label ();
}
#endif // XXX  KUT



void
display_button_click_cb (GtkButton * button)
{
   show_file_in_new_window ();	/* when "Display" button if pressed */
   gtk_widget_set_sensitive (GTK_WIDGET (button), FALSE);

   gtk_widget_set_sensitive (GTK_WIDGET (button), TRUE);
}

short spkcount = 0;

/* should i inc button automatically here??
 */
void
run_button_click_cb (GtkButton * button)
{
   gchar *editString = EDITCMD;
   gchar *accessbuf, *ifbuf;
   GError *error = NULL;
   gchar **argv;
   gint argp;
   gint rc = 0;
   GPid pid;
   gchar *editcmd;

   printf("Entering run_button_click_cb with spkcount = (%d)\n",spkcount); if (looping_flag)
     {
	/*
	   Stop GTK from looping 
	 */
	looping_flag = FALSE;
	gtk_button_set_label (GTK_BUTTON (button), "Run Text-To-Speech");
	return;
     }

   ifbuf = g_strdup_printf ("%s%c%d%s", prefix, DOT, counter, suffix);
   accessbuf = g_build_filename (homedir, VBCPATH, ifbuf, NULL);

   editcmd = g_strdup_printf ("%s %s", editString, accessbuf);
   printf ("\nDEBUG: in run(), cmdbuf = [%s]\n", editcmd);

   rc = g_shell_parse_argv (editcmd, &argp, &argv, NULL);
   //g_free (editcmd);
   //g_free (accessbuf);
   //g_free (ifbuf);
   printf("after g_shell_parse_argv, rc = (%d)\n", rc);


   if (!rc)
     {
	g_strfreev (argv);
	printf ("\nDEBUG: could not parse editor command line");
	return;
     }


   /*
      spawn the editor asynchronously 
    */

   rc = g_spawn_async (NULL, argv, NULL,
		       G_SPAWN_SEARCH_PATH |
		       G_SPAWN_DO_NOT_REAP_CHILD, NULL, NULL, &pid, &error);

   g_strfreev (argv);

   if (!rc)
     {
	printf ("\nDEBUG: Could not spawn editor.");
	if (error)
	   printf ("\nDEBUG: code %d, %s", error->code, error->message);

	looping_flag = FALSE;
	return;
     }

   g_child_watch_add (pid, run_button_click_helper1, button);

   /*
      begin looping 
    */
   looping_flag = TRUE;
   gtk_button_set_label (GTK_BUTTON (button), "Stop Text-To-Speech");
}

void
run_button_click_helper1 (GPid pid, gint status, gpointer userdata)
{
   gchar *accessbuf, *ifbuf;
   gint errorcode;
   gchar *editString = EDITCMD;
   gchar *voice;
   gchar *editcmd;
   GtkButton *button = GTK_BUTTON (userdata);

   GError *error = NULL;
   gchar **argv;
   gint argp;
   gint rc = 0;

   errorcode = WEXITSTATUS (status);

   if (errorcode)
     {
	printf ("\nDEBUG: editor returned exit code %d\n", errorcode);
	/*
	   perhaps do something here if the editor didn't return 
	   * an exit status of 0 
	 */
     }
   g_spawn_close_pid (pid);

   /*
      user clicked on the "Stop Text-To-Speech" button while GVim was running
      * We'll stop looping.  Anything in the gvim buffer won't be spoken.  Maybe
      * not idea, but we either stop looping here before the text is spoken, or
      * after it's spoken. 
    */
   if (!looping_flag)
      return;

   if (prefix)
     {
	ifbuf = g_strdup_printf ("%s%c%d%s", prefix, DOT, counter, suffix);
     }
   else
     {
	ifbuf = g_strdup_printf ("%d%s", counter, suffix);
     }
   accessbuf = g_build_filename (homedir, VBCPATH, ifbuf, NULL);

   /*
      g_spawn_async doesn't run a shell, but we need one 
    */
   voice = g_strdup_printf ("sh -c \"%s -a %i -p %i -s %i %s -f %s %s | %s\"", 
      ESPEAK, valueVolume, valuePitch, valueSpeed, LANG, accessbuf, OUT, APLAY);
   fprintf(stdout, "line 555: voice = [%s]\n", voice);


   rc = g_shell_parse_argv (voice, &argp, &argv, NULL);
   if (!rc)
     {
	g_strfreev (argv);
	printf ("\nDEBUG: could not parse voice command line");
	return;
     }

   printf ("\nDEBUG: in callback_helper2(), cmdbuf = [%s]\n", voice);

   g_free (voice);

   printf("after g_shell_parse_argv, RC = (%d)\n", rc);

   rc = g_spawn_async (NULL, argv, NULL,
		       G_SPAWN_STDOUT_TO_DEV_NULL | G_SPAWN_SEARCH_PATH |
		       G_SPAWN_DO_NOT_REAP_CHILD, NULL, NULL, &pid, &error);

   g_strfreev (argv);

   if (!rc)
     {
	printf ("\nDEBUG: Could not spawn voice speaker.");
	if (error)
	   printf ("\nDEBUG: code %d, %s", error->code, error->message);
	/*
	   dilemma.  Should we abort looping here, or ignore the error? 
	 */
	//return;
     }
   else
     {
	/*
	   we still watch the child for success so we can spit
	   * out any errors, but no looping logic is in this
	   * callback 
	 */
	g_child_watch_add (pid, run_button_click_helper2, button);
     }

   counter++;

   /*
      Update label to show updated counter
    */



   update_label ();		//line #645 06jan12

   //g_free (accessbuf);
   //g_free (ifbuf);
   if (prefix)
     {
	ifbuf = g_strdup_printf ("%s%c%d%s", prefix, DOT, counter, suffix);
     }
   else
     {
	ifbuf = g_strdup_printf ("%d%s", counter, suffix);
     }
   accessbuf = g_build_filename (homedir, VBCPATH, ifbuf, NULL);

   editcmd = g_strdup_printf ("%s %s", editString, accessbuf);
   printf ("\nDEBUG: in run(), cmdbuf = [%s]\n", editcmd);

   rc = g_shell_parse_argv (editcmd, &argp, &argv, NULL);
   //g_free (editcmd);
   //g_free (accessbuf);
   //g_free (ifbuf);

   if (!rc)
     {
	g_strfreev (argv);
	printf ("\nDEBUG: could not parse editor command line");
	return;
     }

   /*
      spawn the editor asynchronously, again because
      * we're looping! 
    */

   rc = g_spawn_async (NULL, argv, NULL,
		       G_SPAWN_SEARCH_PATH |
		       G_SPAWN_DO_NOT_REAP_CHILD, NULL, NULL, &pid, &error);

   g_strfreev (argv);

   if (!rc)
     {
	printf ("\nDEBUG: Could not spawn editor.");
	if (error)
	   printf ("\nDEBUG: code %d, %s", error->code, error->message);
	looping_flag = FALSE;
	gtk_button_set_label (GTK_BUTTON (button), "Run Text-To-Speech");
	return;
     }

   /*
      after gvim finishes, gtk should call this function again 
    */
   g_child_watch_add (pid, run_button_click_helper1, button);
}

void
run_button_click_helper2 (GPid pid, gint status, gpointer userdata)
{
   /*
      this is mainly an error catching routine.  if epeak has an error,
      * it will print to standard out for debugging purposes.  Also it
      * cleans up the child pid structure. 
    */
   gint errorcode;
   //GtkButton *button = GTK_BUTTON(userdata);

   errorcode = WEXITSTATUS (status);

   if (errorcode)
     {
	printf ("\nDEBUG: speaker returned exit code %d\n", errorcode);
     }
   g_spawn_close_pid (pid);
}


static void
entry_changed_cb (GtkEditable * editable, gpointer data)
{
/*
Caller has to free the text, so call g_free and get the complete text
*/
   g_free (prefix);
   prefix = gtk_editable_get_chars (editable, 0, -1);
/*
Update label to show updated prefix
*/
   update_label ();
   return;
}

static const gchar ui_menu[] = 
   "<ui>"
   "  <menubar name='MainMenu'>"
   "    <menu action='File'>"
   "      <menuitem action='New'/>"
   "      <menuitem action='Open'/>"
   "      <menuitem action='Save'/>"
   "      <menuitem action='SaveAs'/>"
   "      <separator/>"
   "      <menuitem action='Quit'/>"
   "    </menu>"
   "    <menu action='Options'>"
   "      <menuitem action='SetVoice'/>"
   "    </menu>"
   "    <menu action='Help'>"
   "      <menuitem action='About'/>"
   "      <menuitem action='Instructions'/>"
   "      <menuitem action='InstrGvim'/>"
   "    </menu>"
   "  </menubar>"
   "</ui>";

static void quit_cb(GtkAction *action, GtkWidget *window)
{
   gtk_widget_destroy (window);
}

static const GtkActionEntry menu_entries[] = {
   {"File", NULL, "_File"},
   {"New", GTK_STOCK_NEW, NULL, NULL, NULL, print_hello},
   {"Open", GTK_STOCK_OPEN, NULL, NULL, NULL, print_hello},
   {"Save", GTK_STOCK_SAVE, NULL, NULL, NULL, print_hello},
   {"SaveAs", GTK_STOCK_SAVE_AS, NULL, NULL, NULL, print_hello},
   {"Quit", GTK_STOCK_QUIT, NULL, NULL, NULL, G_CALLBACK(quit_cb)},
   {"Options", NULL, "_Options"},
   {"SetVoice", NULL, "Set Voice", NULL, NULL, G_CALLBACK(Xoptions)},
   {"Help", NULL, "_Help"},
   {"About", GTK_STOCK_ABOUT, NULL, NULL, NULL, G_CALLBACK(cb_on_about)},
   {"Instructions", NULL, "How to Use", NULL, NULL, G_CALLBACK(show_instructions_cb)},
   {"InstrGvim", NULL, "Using Gvim", NULL, NULL, G_CALLBACK(show_gvim_cb)}
};

void
get_main_menu (GtkWidget * window, GtkWidget ** menubar)
{
   GtkUIManager *menu_ui = gtk_ui_manager_new ();
   GtkActionGroup *action_group;
   GtkAccelGroup *accel_group;

   action_group = gtk_action_group_new ("MenuActions");
   gtk_action_group_add_actions (action_group, menu_entries, G_N_ELEMENTS (menu_entries), window);

   gtk_ui_manager_insert_action_group (menu_ui, action_group, 0);
   accel_group = gtk_ui_manager_get_accel_group (menu_ui);
   gtk_window_add_accel_group (GTK_WINDOW (window), accel_group);

   gtk_ui_manager_add_ui_from_string (menu_ui, ui_menu, -1, NULL);

   *menubar = gtk_ui_manager_get_widget (menu_ui, "/MainMenu");
}

void
initialize ()
{
   gchar *ifbuf, *accessbuf;



    valueVolume = VOLUME;
     valuePitch = PITCH;
      valueSpeed = SPEED;

   homedir = g_getenv ("HOME");

   if (!homedir)
      homedir = g_get_home_dir ();

   looping_flag = FALSE;
   prefix = g_strdup(DEFAULT);

   ifbuf = g_strdup_printf ("%s%c%d%s", prefix, DOT, counter, suffix);

   accessbuf = g_build_filename (homedir, VBCPATH, ifbuf, NULL);
   vhome = g_build_filename (homedir, VBCPATH, NULL);

   if (g_file_test (vhome, G_FILE_TEST_IS_DIR))
     {
	printf ("vhome = [%s] exists!\n", vhome);
     }

   printf ("DEBUG: initialize(): accessbuf = [%s], \nvhome = [%s]\n",
	   accessbuf, vhome);

   //////g_free (accessbuf);
   //g_free (ifbuf);
}

int
main (int argc, char *argv[])
{
   //GtkWidget *button_inc, *button_dec;  KUT
   GtkWidget *entry_label;
   GtkWidget *entry, *button;
   GtkWidget *window;
   GtkWidget *vbox, *hbox, *align;
   GtkWidget *separator, *menubar;
   GtkWidget *display, *run;

   initialize ();		// where many global buffers are set _once_
   gtk_init (&argc, &argv);
   window = gtk_window_new (GTK_WINDOW_TOPLEVEL);

   gtk_window_set_position (GTK_WINDOW (window), GTK_WIN_POS_CENTER);
   gtk_window_set_title (GTK_WINDOW (window), "VoiceByComputer");
   g_signal_connect (window, "destroy", G_CALLBACK (gtk_main_quit),
		     NULL);

   // Menubar
   vbox = gtk_vbox_new (FALSE, 5);
   gtk_container_add (GTK_CONTAINER (window), vbox);	// 04feb 12:25
   gtk_container_set_border_width (GTK_CONTAINER (window), 15);
   gtk_container_set_border_width (GTK_CONTAINER (vbox), 1);
   get_main_menu (window, &menubar);
   gtk_box_pack_start (GTK_BOX (vbox), menubar, FALSE, TRUE, 0);


   label = gtk_label_new ("");
   update_label ();		// this prints out {prefix}N.txt ---

/*
* align buttons. Create "align" Widget for allignment of child.
*/
   align = gtk_alignment_new (0.5, 0.5, 0, 0);
   gtk_widget_show (align);

   hbox = gtk_hbox_new (FALSE, 2);	/* create new/first hbox widget */
   gtk_container_add (GTK_CONTAINER (vbox), hbox);	/* SUCCESS */

   entry_label = gtk_label_new ("Or type in your own filename prefix below:");
   entry = gtk_entry_new ();
   gtk_entry_set_max_length (GTK_ENTRY (entry), 13);

   g_signal_connect (entry, "changed", G_CALLBACK (entry_changed_cb), NULL);

   gtk_box_pack_start (GTK_BOX (vbox), label, 0, 0, 0);
   gtk_box_pack_start (GTK_BOX (vbox), entry_label, 0, 0, 0);
   gtk_box_pack_start (GTK_BOX (vbox), entry, 0, 0, 0);

   separator = gtk_hseparator_new ();
   gtk_box_pack_start (GTK_BOX (vbox), separator, FALSE, TRUE, 0);

   display = gtk_button_new_from_stock ("Display Text");

   g_signal_connect (display, "clicked",
		     G_CALLBACK (display_button_click_cb), NULL);
   gtk_box_pack_start (GTK_BOX (vbox), display, 0, 0, 0);

   run = gtk_button_new_from_stock ("Run Text-To-Speech");
   g_signal_connect (run, "clicked", G_CALLBACK (run_button_click_cb), NULL);

   gtk_box_pack_start (GTK_BOX (vbox), run, 0, 0, 0);


/* start EXP */

   entry = gtk_entry_new ();
   gtk_entry_set_max_length (GTK_ENTRY(entry), 50);
   g_signal_connect (entry, "activate",
		       G_CALLBACK (enter_callback), NULL);

   hbox = gtk_hbox_new (FALSE, 0);
   gtk_container_add (GTK_CONTAINER (vbox), hbox);

   button = gtk_button_new_with_label ("Quit");
   g_signal_connect_swapped (button, "clicked",
			      G_CALLBACK (gtk_widget_destroy),
			      window);
   gtk_box_pack_start (GTK_BOX (vbox), button, TRUE, TRUE, 0);
   gtk_widget_set_receives_default (button, TRUE);

/* END EXPERIMENTAL, MISSING TWO _SHOW() CALLS */

   gtk_widget_show_all (window);

   gtk_main ();

   g_free (prefix);
   //g_free (vhome);

   return 0;
}

